! cf. $SAS_DIR/packages/dal/tests/f90test/setcolumn.f90

program mkdata_bkgoptrate

  use dal
  
  implicit none

  integer, parameter :: DEFAULTDIMENSION = 7

  type(DataSetT) :: setRate, setCnt, setFrac
  type(TableT) :: tab
  type(ColumnT) :: colX, colRate, colCnt, colFrac
  real(kind=single), dimension(:), pointer :: cX, cRate, cCnt, cFrac
  real(kind=single), dimension(DEFAULTDIMENSION) :: time, rate, cnt, frac
  integer,           dimension(DEFAULTDIMENSION) :: tSeriesInt, timeInt
  ! character(len=1024) :: s
  integer i

  timeInt(:) =     (/ -2, 0, 1, 2, 3, 4, 5 /)
  tSeriesInt(:) = (/ 1, 2, 3, 4, 5, 8, 9 /)
  rate(:)  = tSeriesInt
  cnt(:) = tSeriesInt

  setRate = dataSet("testdata/test_rate.fits",CREATE)
  tab = addTable(setRate,"TIME-SERIES",DEFAULTDIMENSION)
  colX = addColumn(tab,"TIME",REAL32,units="s",comment="real32 column")
  cX => real32Data(colX)
  cX(:) = timeInt

  colRate = addColumn(tab,"RATE",REAL32,units="cnt/s",comment="real32 column")
  cRate => real32Data(colRate)
  cRate(:) = tSeriesInt
  call release(setRate)


  setCnt = dataSet("testdata/test_cnt.fits",CREATE)
  tab = addTable(setCnt,"TIME-SERIES",DEFAULTDIMENSION)
  colX = addColumn(tab,"TIME",REAL32,units="s",comment="real32 column")
  cX => real32Data(colX)
  cX(:) = timeInt

  colCnt = addColumn(tab,"COUNTS",REAL32,units="cnt",comment="real32 column")
  cCnt => real32Data(colCnt)
  cCnt(:) = tSeriesInt
  call release(setCnt)


  setFrac = dataSet("testdata/test_frac.fits",CREATE)
  tab = addTable(setFrac,"TIME-SERIES",DEFAULTDIMENSION)
  colX = addColumn(tab,"TIME",REAL32,units="s",comment="real32 column")
  cX => real32Data(colX)
  cX(:) = timeInt

  colRate = addColumn(tab,"RATE",REAL32,units="cnt/s",comment="real32 column")
  cRate => real32Data(colRate)
  cRate(:) = tSeriesInt

  colFrac = addColumn(tab,"FRACEXP",REAL32,units="",comment="real32 column")
  cFrac => real32Data(colFrac)
  cFrac(:) = 1.0
  cFrac(5) = 0.5
  cFrac(6) = 0.5
  call release(setFrac)

end program mkdata_bkgoptrate
